package com.openhis.web.departmentmanage.appservice.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.core.common.core.domain.R;
import com.core.common.utils.AssignSeqUtil;
import com.core.common.utils.DateUtils;
import com.core.common.utils.MessageUtils;
import com.openhis.common.constant.CommonConstants;
import com.openhis.common.constant.PromptMsgConstant;
import com.openhis.common.enums.*;
import com.openhis.common.utils.EnumUtils;
import com.openhis.web.departmentmanage.appservice.IDepartmentCommonService;
import com.openhis.web.departmentmanage.appservice.IDepartmentTransferInOrderService;
import com.openhis.web.departmentmanage.dto.DepartmentDetailDto;
import com.openhis.web.departmentmanage.dto.DepartmentInitDto;
import com.openhis.web.departmentmanage.mapper.DepartmentCommonMapper;
import com.openhis.web.inventorymanage.dto.ProductStocktakingInitDto;
import com.openhis.workflow.domain.SupplyRequest;
import com.openhis.workflow.service.ISupplyRequestService;

/**
 * 科室材料调入单
 *
 * @author yuxj
 * @date 2025-07-22
 */
@Service
public class DepartmentTransferInOrderServiceImpl implements IDepartmentTransferInOrderService {

    @Resource
    private AssignSeqUtil assignSeqUtil;
    @Resource
    private ISupplyRequestService supplyRequestService;
    @Autowired
    private IDepartmentCommonService departmentCommonService;
    @Autowired
    private DepartmentCommonMapper departmentCommonMapper;

    /**
     * 初始化
     *
     * @return 初始化信息
     */
    @Override
    public R<?> init() {

        DepartmentInitDto purchaseOrderInitDto = departmentCommonService.init();

        // 单据分类
        List<DepartmentInitDto.IntegerOption> supplyCategoryOption = new ArrayList<>();
        // supplyCategoryOption.add(new DepartmentInitDto.IntegerOption(SupplyCategory.NORMAL.getValue(),
        // SupplyCategory.NORMAL.getInfo()));

        purchaseOrderInitDto.setSupplyCategoryOptions(supplyCategoryOption);

        return R.ok(purchaseOrderInitDto);
    }

    /**
     * 调入单单据详情
     *
     * @param busNo 单据号
     * @param pageNo 当前页码
     * @param pageSize 查询条数
     * @return 调入单单据详情
     */
    @Override
    public R<?> getDetailPage(String busNo, Integer pageNo, Integer pageSize) {

        Page<DepartmentDetailDto> transferInOrderDtoDetailPage =
            departmentCommonMapper.getDetailPage(new Page<>(pageNo, pageSize), busNo);

        transferInOrderDtoDetailPage.getRecords().forEach(e -> {
            // 单据分类
            e.setCategoryEnum_enumText(EnumUtils.getInfoByValue(SupplyCategory.class, e.getCategoryEnum()));
            // 单据状态
            e.setStatusEnum_enumText(EnumUtils.getInfoByValue(SupplyStatus.class, e.getStatusEnum()));
            // 单据类型
            e.setTypeEnum_enumText(EnumUtils.getInfoByValue(SupplyType.class, e.getTypeEnum()));
        });

        List<DepartmentDetailDto.Option> unitList;
        for (DepartmentDetailDto item : transferInOrderDtoDetailPage.getRecords()) {
            unitList = new ArrayList<>();
            unitList.add(new DepartmentDetailDto.Option(item.getMaxUnitCode(), item.getMaxUnitCode_dictText()));
            unitList.add(new DepartmentDetailDto.Option(item.getMinUnitCode(), item.getMinUnitCode_dictText()));

            item.setUnitList(unitList);
        }

        return R.ok(transferInOrderDtoDetailPage);
    }

    /**
     * 获取单据号
     *
     * @return 初始化信息
     */
    @Override
    public R<?> getBusNo() {

        ProductStocktakingInitDto initDto = new ProductStocktakingInitDto();
        // 单据号
        initDto.setBusNo(assignSeqUtil.getSeqByDay(AssignSeqEnum.DEPARTMENT_TRANSFERIN.getPrefix(), 4));

        return R.ok(initDto);
    }

    /**
     * 添加/编辑调出单
     *
     * @param transferInOrderDtoList 调出信息
     * @return 操作结果
     */

    @Override
    public R<?> addOrEditTransferInOrder(List<DepartmentDetailDto> transferInOrderDtoList) {
        // 请求数据取得
        List<SupplyRequest> requestList =
            supplyRequestService.getSupplyByBusNo(transferInOrderDtoList.get(0).getBusNo());
        if (!requestList.isEmpty()) {
            // 请求id取得
            List<Long> requestIdList = requestList.stream().map(SupplyRequest::getId).collect(Collectors.toList());
            // 单据信息删除
            supplyRequestService.removeByIds(requestIdList);
        }

        List<SupplyRequest> supplyRequestList = new ArrayList<>();
        Date applyTime = DateUtils.getNowDate();
        for (DepartmentDetailDto item : transferInOrderDtoList) {
            SupplyRequest supplyRequest = new SupplyRequest().setBusNo(item.getBusNo())
                .setTypeEnum(SupplyType.DEPARTMENT_TRANSFERIN.getValue())
                .setStatusEnum(SupplyStatus.PENDING_REVIEW.getValue())
                .setItemTable(CommonConstants.TableName.ADM_DEVICE_DEFINITION).setItemId(item.getItemId())
                .setUnitCode(item.getUnitCode()).setItemQuantity(item.getItemQuantity()).setRetailPrice(item.getPrice())
                .setTotalRetailPrice(item.getTotalPrice()).setBatchInventory(item.getBatchInventory())
                .setSpecificationInventory(item.getSpecificationInventory()).setEndTime(item.getEndTime())
                .setLotNumber(item.getLotNumber()).setTraceNo(item.getTraceNo())
                .setTraceNoUnitCode(item.getTraceNoUnitCode()).setSupplierId(item.getSupplierId())
                .setReason(item.getReason()).setSourceTypeEnum(LocationForm.DEPARTMENT.getValue())
                .setSourceLocationId(item.getSourceLocationId()).setPurposeTypeEnum(LocationForm.DEPARTMENT.getValue())
                .setPurposeLocationId(item.getPurposeLocationId()).setApplicantId(item.getApplicantId())
                .setApplyTime(applyTime).setRemake(item.getRemake());
            supplyRequestList.add(supplyRequest);
        }
        // 更新请求表
        boolean flg = supplyRequestService.saveOrUpdateBatch(supplyRequestList);
        if (!flg) {
            return R.fail(MessageUtils.createMessage(PromptMsgConstant.Common.M00011, null));
        }

        return R.ok(MessageUtils.createMessage(PromptMsgConstant.Common.M00004, null));
    }

}
